# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecEvalRuleArgs', 'AppSecEvalRule']

@pulumi.input_type
class AppSecEvalRuleArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 rule_action: pulumi.Input[str],
                 rule_id: pulumi.Input[int],
                 security_policy_id: pulumi.Input[str],
                 condition_exception: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AppSecEvalRule resource.
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] rule_action: Action to be taken when the evaluation rule is triggered
        :param pulumi.Input[int] rule_id: Unique identifier of the evaluation rule being modified
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        :param pulumi.Input[str] condition_exception: JSON-formatted condition and exception information for the evaluation rule
        """
        AppSecEvalRuleArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            config_id=config_id,
            rule_action=rule_action,
            rule_id=rule_id,
            security_policy_id=security_policy_id,
            condition_exception=condition_exception,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             config_id: pulumi.Input[int],
             rule_action: pulumi.Input[str],
             rule_id: pulumi.Input[int],
             security_policy_id: pulumi.Input[str],
             condition_exception: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'configId' in kwargs:
            config_id = kwargs['configId']
        if 'ruleAction' in kwargs:
            rule_action = kwargs['ruleAction']
        if 'ruleId' in kwargs:
            rule_id = kwargs['ruleId']
        if 'securityPolicyId' in kwargs:
            security_policy_id = kwargs['securityPolicyId']
        if 'conditionException' in kwargs:
            condition_exception = kwargs['conditionException']

        _setter("config_id", config_id)
        _setter("rule_action", rule_action)
        _setter("rule_id", rule_id)
        _setter("security_policy_id", security_policy_id)
        if condition_exception is not None:
            _setter("condition_exception", condition_exception)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="ruleAction")
    def rule_action(self) -> pulumi.Input[str]:
        """
        Action to be taken when the evaluation rule is triggered
        """
        return pulumi.get(self, "rule_action")

    @rule_action.setter
    def rule_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "rule_action", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Input[int]:
        """
        Unique identifier of the evaluation rule being modified
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Input[str]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "security_policy_id", value)

    @property
    @pulumi.getter(name="conditionException")
    def condition_exception(self) -> Optional[pulumi.Input[str]]:
        """
        JSON-formatted condition and exception information for the evaluation rule
        """
        return pulumi.get(self, "condition_exception")

    @condition_exception.setter
    def condition_exception(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "condition_exception", value)


@pulumi.input_type
class _AppSecEvalRuleState:
    def __init__(__self__, *,
                 condition_exception: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 rule_action: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AppSecEvalRule resources.
        :param pulumi.Input[str] condition_exception: JSON-formatted condition and exception information for the evaluation rule
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] rule_action: Action to be taken when the evaluation rule is triggered
        :param pulumi.Input[int] rule_id: Unique identifier of the evaluation rule being modified
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        _AppSecEvalRuleState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            condition_exception=condition_exception,
            config_id=config_id,
            rule_action=rule_action,
            rule_id=rule_id,
            security_policy_id=security_policy_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             condition_exception: Optional[pulumi.Input[str]] = None,
             config_id: Optional[pulumi.Input[int]] = None,
             rule_action: Optional[pulumi.Input[str]] = None,
             rule_id: Optional[pulumi.Input[int]] = None,
             security_policy_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'conditionException' in kwargs:
            condition_exception = kwargs['conditionException']
        if 'configId' in kwargs:
            config_id = kwargs['configId']
        if 'ruleAction' in kwargs:
            rule_action = kwargs['ruleAction']
        if 'ruleId' in kwargs:
            rule_id = kwargs['ruleId']
        if 'securityPolicyId' in kwargs:
            security_policy_id = kwargs['securityPolicyId']

        if condition_exception is not None:
            _setter("condition_exception", condition_exception)
        if config_id is not None:
            _setter("config_id", config_id)
        if rule_action is not None:
            _setter("rule_action", rule_action)
        if rule_id is not None:
            _setter("rule_id", rule_id)
        if security_policy_id is not None:
            _setter("security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="conditionException")
    def condition_exception(self) -> Optional[pulumi.Input[str]]:
        """
        JSON-formatted condition and exception information for the evaluation rule
        """
        return pulumi.get(self, "condition_exception")

    @condition_exception.setter
    def condition_exception(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "condition_exception", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="ruleAction")
    def rule_action(self) -> Optional[pulumi.Input[str]]:
        """
        Action to be taken when the evaluation rule is triggered
        """
        return pulumi.get(self, "rule_action")

    @rule_action.setter
    def rule_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_action", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[int]]:
        """
        Unique identifier of the evaluation rule being modified
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)


class AppSecEvalRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 condition_exception: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 rule_action: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a AppSecEvalRule resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] condition_exception: JSON-formatted condition and exception information for the evaluation rule
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] rule_action: Action to be taken when the evaluation rule is triggered
        :param pulumi.Input[int] rule_id: Unique identifier of the evaluation rule being modified
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecEvalRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AppSecEvalRule resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AppSecEvalRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecEvalRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            AppSecEvalRuleArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 condition_exception: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 rule_action: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecEvalRuleArgs.__new__(AppSecEvalRuleArgs)

            __props__.__dict__["condition_exception"] = condition_exception
            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if rule_action is None and not opts.urn:
                raise TypeError("Missing required property 'rule_action'")
            __props__.__dict__["rule_action"] = rule_action
            if rule_id is None and not opts.urn:
                raise TypeError("Missing required property 'rule_id'")
            __props__.__dict__["rule_id"] = rule_id
            if security_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_policy_id'")
            __props__.__dict__["security_policy_id"] = security_policy_id
        super(AppSecEvalRule, __self__).__init__(
            'akamai:index/appSecEvalRule:AppSecEvalRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            condition_exception: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            rule_action: Optional[pulumi.Input[str]] = None,
            rule_id: Optional[pulumi.Input[int]] = None,
            security_policy_id: Optional[pulumi.Input[str]] = None) -> 'AppSecEvalRule':
        """
        Get an existing AppSecEvalRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] condition_exception: JSON-formatted condition and exception information for the evaluation rule
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] rule_action: Action to be taken when the evaluation rule is triggered
        :param pulumi.Input[int] rule_id: Unique identifier of the evaluation rule being modified
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecEvalRuleState.__new__(_AppSecEvalRuleState)

        __props__.__dict__["condition_exception"] = condition_exception
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["rule_action"] = rule_action
        __props__.__dict__["rule_id"] = rule_id
        __props__.__dict__["security_policy_id"] = security_policy_id
        return AppSecEvalRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="conditionException")
    def condition_exception(self) -> pulumi.Output[Optional[str]]:
        """
        JSON-formatted condition and exception information for the evaluation rule
        """
        return pulumi.get(self, "condition_exception")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="ruleAction")
    def rule_action(self) -> pulumi.Output[str]:
        """
        Action to be taken when the evaluation rule is triggered
        """
        return pulumi.get(self, "rule_action")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Output[int]:
        """
        Unique identifier of the evaluation rule being modified
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[str]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

